//
//  ButtonViewController.swift
//  Button
//
//  Created by Orkhan Alikhanov on 10/9/18.
//  Copyright © 2018 CosmicMind. All rights reserved.
//

import Material

class ButtonViewController: AppViewController {
  struct ButtonLayout {
    struct Flat {
      static let width: CGFloat = 120
      static let height: CGFloat = 44
      static let offsetY: CGFloat = -150
    }
    
    struct Raised {
      static let width: CGFloat = 150
      static let height: CGFloat = 44
      static let offsetY: CGFloat = -75
    }
    
    struct Fab {
      static let diameter: CGFloat = 48
    }
    
    struct Icon {
      static let width: CGFloat = 120
      static let height: CGFloat = 48
      static let offsetY: CGFloat = 75
    }
  }
  
  
  override func prepare() {
    super.prepare()
    title = title ?? "Button"
    
    let flatButton = FlatButton(title: "Flat Button")
    view.layout(flatButton)
      .width(ButtonLayout.Flat.width)
      .height(ButtonLayout.Flat.height)
      .center(offsetY: ButtonLayout.Flat.offsetY)
    
    
    let raisedButton = RaisedButton(title: "Raised Button", titleColor: .white)
    view.layout(raisedButton)
      .width(ButtonLayout.Raised.width)
      .height(ButtonLayout.Raised.height)
      .center(offsetY: ButtonLayout.Raised.offsetY)
    
    
    let fabButton = FABButton(image: Icon.cm.add, tintColor: .white)
    view.layout(fabButton)
      .width(ButtonLayout.Fab.diameter)
      .height(ButtonLayout.Fab.diameter)
      .center()
    
    
    let iconButton = IconButton(image: Icon.cm.search)
    view.layout(iconButton)
      .width(ButtonLayout.Icon.width)
      .height(ButtonLayout.Icon.height)
      .center(offsetY: ButtonLayout.Icon.offsetY)
    
  }
}
